#ifndef DEF_GENE_FUSIONS_CONFIG_H
#define DEF_GENE_FUSIONS_CONFIG_H

// Used by bowtie (gfrHomologyFilter.c, gfr2bpJunctions.c, validateBpJunctions.c)
// Location of the bowtie indexes of the human genome and the composite model
#define BOWTIE_INDEXES "/path2bowtieIndexes" 
// the subdirectory of BOWTIE_INDEXES where the human genome is indexed by bowtie-build
#define BOWTIE_GENOME "hg18_nh"
// the subdirectory of BOWTIE_INDEXES where the composite model is indexed by bowtie-build
#define BOWTIE_COMPOSITE "hg18_knownGeneAnnotationTranscriptCompositeModel"

// Pointer to the program twoBitToFa part of the blat suite
#define BLAT_TWO_BIT_TO_FA "/path2blat/twoBitToFa" 
// Location and filename of  the reference genome in 2bit format (to be used by blat)
#define BLAT_DATA_DIR "/path2blatDataDir"
#define BLAT_TWO_BIT_DATA_FILENAME "hg18.2bit"

// Location and name of the transcript composite model sequence AND interval file
#define TRANSCRIPT_COMPOSITE_MODEL_DIR "/path2transcriptCompositeModel"
// file name of the composite model sequence file
#define TRANSCRIPT_COMPOSITE_MODEL_FA_FILENAME "knownGeneAnnotationTranscriptCompositeModel.fa"
// file name of the composite model interval file
#define TRANSCRIPT_COMPOSITE_MODEL_FILENAME "knownGeneAnnotationTranscriptCompositeModel.txt" 

// location of the annotation files
#define ANNOTATION_DIR "/path2annotationFiles" 
// conversion of knownGenes to gene symbols, description, etc. 
#define KNOWN_GENE_XREF_FILENAME "kgXref.txt" 
// conversion of knownGenes to TreeFam
#define KNOWN_GENE_TREE_FAM_FILENAME "knownToTreefam.txt" 

// Location and filename of the ribosomal library
#define RIBOSOMAL_DIR "/path2ribosomalDir"
#define RIBOSOMAL_FILENAME "ribosomal.2bit"

// ----------------------- This section is optional: visualization tools -------------------------
// URL of the cgi directory on the web server
#define WEB_URL_CGI "http://cgiURL" 
// location of the data directory on the web server, as seen from the web server
#define WEB_DATA_DIR "/path2data" 
// URL of the data directory on the web server
#define WEB_DATA_LINK "http://dataURL" 
// Number of nucleotides flanking the region (for UCSC Genome Browser)
#define UCSC_GENOME_BROWSER_FLANKING_REGION 500 

// URL of the public website (non cgi)
#define WEB_PUB_DIR "http://publicURL" 
// Location of the structural data for Circos
#define WEB_SDATA_DIR "/path2structuralDataCircos" 
// Location of Circos installation
#define WEB_CIRCOS_DIR "/path2circos" 


#endif
